Learn how easy it is to sync an existing GitHub or Google Code repo to a SourceForge project! See Demo

Close

#3876 G clef at 'smaller' sizes looks poor

Verified
nobody
Ugly
2014-04-21
2014-02-27
Anonymous
No

Originally created by: *anonymous

Originally created by: pkx1...@gmail.com
Originally owned by: lemzw...@googlemail.com

\version "2.19.2"

#(set-global-staff-size 18)

\clef treble

1 Attachments

Discussion

  • Originally posted by: pkx1...@gmail.com

    On 25/02/14 08:11, Janek Warchoł wrote:
    > 2014-02-24 23:02 GMT+01:00 Werner LEMBERG <wl@gnu.org>:
    >>
    >>> \version "2.19.2"
    >>>
    >>> #(set-global-staff-size 18)
    >>>
    >>> \clef treble
    >>
    >> Are you using a self-compiled version of LilyPond?  It seems that you
    >> are using a broken metapost version.  However, we have a special
    >> `configure' test to prevent that...
    >
    > I confirm that i get the same results as Karol with official 2.19.2-1
    > 64-bit release for Linux.  However, when compiled from source
    > ([r2d7f24a561e12464b369fb9d25c7185d80412e35]) on my Ubuntu 12.04, it
    > looks ok.
    >
    > :-(
    > Janek

     
  • Originally posted by: pkx1...@gmail.com

    2014-02-25 9:27 GMT+01:00 Pierre Perol-Schneider <
    pierre.schneider.paris@gmail.com>
    >
    >
    > I confirm also (Win 7, did not try under Ubuntu yet)
    > What I can add is that it appears between size #12 till size #18, then
    > size #24 and higher.

     
  • Originally posted by: pkx1...@gmail.com

    On 25/02/14 06:22, James wrote:
    > Hello,
    >
    > I noticed during the make process and while all that 'stuff' wizzes passed the screen a point where there were lots of 'Internal Error' messages displayed.
    >
    > I have run another make this morning and if I grep for that string I get references to one or two clefs that I think are to do with the recent commit
    >
    > http://git.savannah.gnu.org/gitweb/?p=lilypond.git;a=commit;h=476c0adbf748f1adcb6927a6197d13f3790c8a9b
    > I have attached the text file here but for a snippet I have things like
    >
    > --snip--
    > Internal Error (overlap) in clefs.G: Intersection failed!
    > Internal Error (overlap) in clefs.G: Intersection failed!
    > Internal Error (overlap) in scripts.lineprall: Resetting end. was: (-313.567,0.713886) now: (-313.567,0.713886)
    > Internal Error (overlap) in scripts.lineprall: Resetting _start. was: (-313.567,0.713886) now: (-313.567,0.713886)
    > Internal Error (overlap) in scripts.lineprall: Intersection (-313.567,0.713886) not on a monotonic which should contain it.
    > Internal Error (overlap) in scripts.lineprall: Intersection (-313.567,0.713886) not on a monotonic which should contain it.
    > --snip--
    >
    > and
    >
    > --snip--
    > Internal Error (overlap) in clefs.tenorG: Intersection failed!
    > Internal Error (overlap) in clefs.tenorG_change: monotonic is both needed and unneeded (135.13,46.1871)->(263.138,206.915). x=192.984 (prev=219.333)
    > Internal Error (overlap) in clefs.tenorG_change: monotonic is both needed and unneeded (204.182,324.002)->(62.6575,18.8297). x=192.984 (prev=175.457)
    > Internal Error (overlap) in clefs.tenorG: Intersection failed!
    > Internal Error (overlap) in clefs.tenorG: Intersection failed!
    > Internal Error (overlap) in clefs.tenorG_change: monotonic is both needed and unneeded (192.984,456.598)->(162.351,574). y=456.598 (prev=192.984)
    > Internal Error (overlap) in clefs.tenorG_change: Winding number did not return to 0 when y=498.065
    > Internal Error (overlap) in clefs.tenorG_change: Humph. This monotonic leads nowhere (225.21,498.065)->(225.21,498.065).
    > Internal Error (overlap) in clefs.tenorG_change: Closing contour with unneeded path
    > Internal Error (overlap) in clefs.tenorG: Intersection failed!
    > Internal Error (overlap) in clefs.G_change: monotonic is both needed and unneeded (134.266,46.3174)->(263.152,207.934). x=191.37 (prev=245.557)
    > Internal Error (overlap) in clefs.G_change: monotonic is both needed and unneeded (225.392,349.166)->(64.0923,17.1972). x=191.37 (prev=162.842)
    > Internal Error (overlap) in clefs.tenorG: Intersection failed!
    > Internal Error (overlap) in clefs.tenorG: monotonic is both needed and unneeded (687.511,61.249)->(687.511,311.25). y=268.907 (prev=368.212)
    > Internal Error (overlap) in clefs.tenorG: monotonic is both needed and unneeded (730.01,424.581)->(730.01,61.249). y=268.907 (prev=368.212)
    > Internal Error (overlap) in clefs.tenorG: Winding number did not return to 0 when y=268.907
    > --snip--

     
  • Originally posted by: pkx1...@gmail.com

    From:     Werner LEMBERG
    Subject:     Re: Internal Error messages being generated during make for some (new) fonts
    Date:     Tue, 25 Feb 2014 07:45:26 +0100 (CET)

    > I noticed during the make process and while all that 'stuff' wizzes
    > passed the screen a point where there were lots of 'Internal Error'
    > messages displayed.

    Indeed, this is the cause of the problem reported recently.  Sigh.
    Will recompile lilypond and check whether the problem persists with a
    recent FontForge snapshot (I no longer have an old FontForge binary).
    I remember that I've tested Marc's changes, and I saw no problems.

        Werner

     
  • Originally posted by: pkx1...@gmail.com

    > I remember that I've tested Marc's changes, and I saw no problems.

    Obviously, I haven't tested all sizes.  Sorry for that.  I can confirm
    that there are problems even with a current fontforge build in
    generating feta14, feta13, and feta11.  Of course, all those problems
    are bugs in fontforge, but we have to work around them
    unfortunately...

        Werner

     
  • Originally posted by: pkx1...@gmail.com

    On 27/02/14 08:16, Werner LEMBERG wrote:
    >>> For the sake of reference: The source of the problem seems to have
    >>> been identified:
    >>> http://lists.gnu.org/archive/html/lilypond-devel/2014-02/msg00238.html
    >>
    >> So does this need a LilyPond Tracker
    >
    > Yes, definitely.
    >
    >> or is this a bug (in fontforge?)?
    >
    > It's basically a bug in fontforge, but we can't rely on a quick fix
    > since this is very unlikely.  Additionally, we rely on the last
    > *published* fontforge version, which was a released quite a long time
    > ago.  Meanwhile, fontforge has been very heavily modified.
    > Unfortunately, not all modifications are bug free; for example, I
    > can't build the feta fonts with current fontforge's current git
    > version due to a very fundamental bug, cf.
    >
    >   https://github.com/fontforge/fontforge/issues/1239
    >
    > The solution to the clef problem is not too difficult, however: We
    > have to slightly modify the outlines of the clefs so that the
    > intersections are `simpler', allowing fontforge to handle the outline
    > correctly.  While reviewing Marc's patch I've only checked one size
    > (feta20), which was an oversight.
    >
    > Marc, do you have time to work on that?
    >
    >
    >     Werner

     
  • Originally posted by: pkx1...@gmail.com

    Phew, I am quite busy at the moment. I will not be able to work on this
    the next couple of weeks, I'm afraid, and I can't say when I'll have
    more time left again. Sorry.

    Marc

     
  • Originally posted by: lemzw...@googlemail.com

    Issue 3876: Fix shape of G clefs

    This patch simplifies the code for the double G clefs; it also fixes the
    incorrect test of the `double_shift' parameter that caused the non-double
    G clefs being drawn twice.

    Recent FontForge warnings like

      Internal Error (overlap) in clefs.G: Intersection failed!

    or the ugly shape with a straight line instead of a curve in the left part
    of the G clef are now gone: Drawing the shape twice triggered a bunch of
    FontForge bugs.

    http://codereview.appspot.com/71960043

    Labels: Patch-new
    Owner: lemzw...@googlemail.com
    Status: Started

     
  • Originally posted by: pkx1...@gmail.com

    Patchy the autobot says: passes make, make check and a full make doc.

    Labels: -Patch-new Patch-review

     
  • Originally posted by: pkx1...@gmail.com

    I also did a manual make on my own system and did not see any more 'Internal Error' messages

     
  • Originally posted by: pkx1...@gmail.com

    Patch on countdown for Mar 13 - 06:00 GMT

    Labels: -Patch-review Patch-countdown

     
  • Originally posted by: pkx1...@gmail.com

    Patch counted down - please push

    Labels: -Patch-countdown Patch-push

     
  • Originally posted by: lemzw...@googlemail.com

    Pushed to staging as

    commit [r2ddf56baf116c987e113d8a0596ef2b0bd39f88e]
    Author: Werner Lemberg <wl@gnu.org>
    Date:   Thu Mar 6 07:19:49 2014 +0100

        Issue 3876: Fix shape of G clefs
       
        This patch simplifies the code for the double G clefs; it also fixes the
        incorrect test of the `double_shift' parameter that caused the non-double
        G clefs being drawn twice.
       
        Recent FontForge warnings like
       
          Internal Error (overlap) in clefs.G: Intersection failed!
       
        or the ugly shape with a straight line instead of a curve in the left part
        of the G clef are now gone: Drawing the shape twice triggered a bunch of
        FontForge bugs.

    Status: Fixed

     
  • Originally posted by: fedel...@gmail.com

    I see in gitk that this commit is after the 2.19.3 release

    Labels: Fixed_2_19_4

     
  • Originally posted by: fedel...@gmail.com

    (No comment was entered for this change.)

    Labels: -Patch-push

     
  • Originally posted by: fedel...@gmail.com

    (No comment was entered for this change.)

    Status: Verified